#ifndef _AUDIOCODE_DOT_H_
#define _AUDIOCODE_DOT_H_

#include <windows.h>
//#include <dsound.h>
#include "AudioSpec.h"


#define SND_IS_NOT_EMPTY 0x4000000
#define SND_IS_FULL		 0x8000000

#define SEGMENTS 3
#define LOCK_SIZE (576*4) //0x1000
#define MAXBUFFER (LOCK_SIZE*SEGMENTS+LOCK_SIZE)
// LOCKSIZE must not be fractional
//#define LOCK_SIZE    (ac->SegmentSize)

#define BUFFSIZE (writeLoc-readLoc)

extern DWORD silencelength;

class AudioCode {
	protected:
		DWORD dwFreqTarget; // Frequency of the Nintendo64 Game Audio
		void (*CallBack)( DWORD );
		BOOL audioIsPlaying;
		//HANDLE handleAudioThread;
		//DWORD  dwAudioThreadId;
		//HANDLE hMutex;
		//LPDIRECTSOUNDBUFFER  lpdsbuf;
		//LPDIRECTSOUND        lpds;
		BOOL audioIsDone;
		// Buffer Variables
		BYTE SoundBuffer[MAXBUFFER];
		DWORD readLoc;
		DWORD writeLoc;
		volatile int remainingBytes;
		DWORD SampleRate;
		DWORD SegmentSize;
		double nexttime;

	public:
		friend DWORD WINAPI AudioThreadProc (AudioCode *ac);

		AudioCode () { /*lpdsbuf=NULL; lpds=NULL;*/ SampleRate=0; audioIsDone = false; /*hMutex=0;*/};
		~AudioCode () { };

		// Setup and Teardown Functions
		BOOL Initialize (void (*AiCallBack)( DWORD ), HWND hwnd);
		BOOL Initialize (HWND hwnd);
		void InitWinampOutput();
		void CloseWinampOutput();
		void DeInitialize ();
		//int GetremainingBytes() {return remainingBytes;}
		BOOL playing() {return audioIsPlaying && !audioIsDone;}

		// Buffer Functions for the Audio Code
		void SetFrequency (DWORD Frequency);		// Sets the Nintendo64 Game Audio Frequency
		DWORD AddBuffer (BYTE *start, DWORD length);	// Uploads a new buffer and returns status
		//void FillBuffer (BYTE *buff, DWORD len);
		void PlayBuffer (void);
		void SetSegmentSize (DWORD length);

		// Management functions
		void StopAudio ();							// Stops the Audio PlayBack (as if paused)
		void StartAudio ();							// Starts the Audio PlayBack (as if unpaused)

		DWORD GetReadStatus ();						// Returns the status on the read pointer
		In_Module * mod;
		double time; // get it ?
		double seektime;
		void (__cdecl *CheckInterrupts)( void );
};

#endif